-- functionsCtr.lua
-- Written By Habna


function ImportCtr( value )
	if value == "MI" then --Money Infos
		import (AppCtrD.."MoneyInfos");
		import (AppCtrD.."MoneyInfosToolTip");
		PlayerAtt = Player:GetAttributes();
		AddCallback(PlayerAtt, "MoneyChanged", function(sender, args) UpdateMoney(); end);
		UpdateMoney();
		MI["Ctr"]:SetPosition( _G.MILocX, _G.MILocY );
	elseif value == "DP" then --Destiny Points
		import (AppCtrD.."DestinyPoints");
		PlayerAtt = Player:GetAttributes();
		AddCallback(PlayerAtt, "DestinyPointsChanged", function(sender, args) UpdateDestinyPoints(); end);
		UpdateDestinyPoints();
		DP["Ctr"]:SetPosition( _G.DPLocX, _G.DPLocY );
	elseif value == "SP" then --Shards
		import (AppCtrD.."Shards");
		LoadPlayerWallet();
		--PlayerShard = PlayerCurrency["Shard"];
		--AddCallback(PlayerShard, "QuantityChanged", function(sender, args) UpdateShards(); end);
		UpdateShards();
		SP["Ctr"]:SetPosition( _G.SPLocX, _G.SPLocY );
	elseif value == "SM" then --Skirmish Marks
		import (AppCtrD.."SkirmishMarks");
		LoadPlayerWallet();
		--PlayerMark = PlayerCurrency["Mark"];
		--AddCallback(PlayerMark, "QuantityChanged", function(sender, args) UpdateMarks(); end);
		UpdateMarks();
		SM["Ctr"]:SetPosition( _G.SMLocX, _G.SMLocY );
	elseif value == "MP" then --Medallions
		import (AppCtrD.."Medallions");
		LoadPlayerWallet();
		--PlayerShard = PlayerCurrency["Medallion"];
		--AddCallback(PlayerShard, "QuantityChanged", function(sender, args) UpdateMedallions(); end);
		UpdateMedallions();
		MP["Ctr"]:SetPosition( _G.MPLocX, _G.MPLocY );
	elseif value == "SL" then --Seals
		import (AppCtrD.."Seals");
		LoadPlayerWallet();
		--PlayerSeals = PlayerCurrency["Seals"];
		--AddCallback(PlayerSeals, "QuantityChanged", function(sender, args) UpdateSeals(); end);
		UpdateSeals();
		SL["Ctr"]:SetPosition( _G.SLLocX, _G.SLLocY );
	elseif value == "CP" then --Commendations
		import (AppCtrD.."Commendations");
		LoadPlayerWallet();
		--PlayerCommendation = PlayerCurrency["Commendation"];
		--AddCallback(PlayerCommendation, "QuantityChanged", function(sender, args) UpdateCommendations(); end);
		UpdateCommendations();
		CP["Ctr"]:SetPosition( _G.CPLocX, _G.CPLocY );
	elseif value == "BI" then --Backpack Infos
		import (AppCtrD.."BagInfos");
		import (AppCtrD.."BagInfosToolTip");
		Backpack = Player:GetBackpack();
		AddCallback(Backpack, "ItemAdded", function(sender, args) UpdateBackpackInfos(); end);
		AddCallback(Backpack, "ItemRemoved", function(sender, args) ItemRemovedTimer:SetWantsUpdates( true ); end); --Workaround
		--AddCallback(Backpack, "ItemRemoved", function(sender, args) UpdateBackpackInfos(); end);
		UpdateBackpackInfos();
		BI["Ctr"]:SetPosition( _G.BILocX, _G.BILocY );
	elseif value == "PI" then --Player Infos
		import (AppCtrD.."PlayerInfos");
		import (AppCtrD.."PlayerInfosToolTip");
		AddCallback(Player, "LevelChanged", function(sender, args) PI["Lvl"]:SetText( Player:GetLevel() ); end);
		AddCallback(Player, "NameChanged", function(sender, args) PI["Name"]:SetText( Player:GetName() ); end);
		UpdatePlayersInfos();
		PI["Ctr"]:SetPosition( _G.PILocX, _G.PILocY );
	elseif value == "DI" then --Durability Infos
		import (AppCtrD.."DurabilityInfos");
		import (AppCtrD.."DurabilityInfosToolTip");
		UpdateDurabilityInfos();
		DI["Ctr"]:SetPosition( _G.DILocX, _G.DILocY );
	elseif value == "EI" then --Equipment Infos
		import (AppCtrD.."EquipInfos");
		import (AppCtrD.."EquipInfosToolTip");
		UpdateEquipsInfos();
		EI["Ctr"]:SetPosition( _G.EILocX, _G.EILocY );
	elseif value == "PL" then --Player Location
		import (AppCtrD.."PlayerLoc");
		AddCallback(
		Turbine.Chat, "Received", function(sender, args)
			sMess = args.Message;

			----                1111111111222222222233333333 
			----       1234567890123456789012345678901234567
			--sMess = "Entered the Bree-town - Trade channel";

			if sMess ~= nil then
				if GLocale == "en" then sS, sE = "Entered the ", "-%s";
				elseif GLocale == "fr" then sS, sE = "Canal ", "-%s";
				elseif GLocale == "de" then sS, sE = "Kanal ", "-%s"; end

				local s,e = string.find(sMess, sS);
				if s ~= nil then
					local first = e + 1;
					local s,e = string.find(sMess, sE);
					local last = s - 2;
					-- Extract Location from args.Message
					pLLoc = string.sub( sMess, first, last );
					UpdatePlayerLoc( pLLoc );
					settings.PlayerLoc.L = pLLoc;
					SaveSettings( false );
				end
			end
		end);
		UpdatePlayerLoc( pLLoc );
		PL["Ctr"]:SetPosition( _G.PLLocX, _G.PLLocY );
	elseif value == "IF" then --Infamy
		import (AppCtrD.."Infamy");
		import (AppCtrD.."InfamyToolTip");
		---InfamyCount = Turbine.
		--AddCallback(InfamyCount, "QuantityChanged", function(sender, args) UpdateInfamy(); end);
		AddCallback(
		Turbine.Chat, "Received", function(sender, args)
			if args.ChatType == Turbine.ChatType.Advancement then
				sMess = args.Message;
				--GLocale = "en"; --debug purpose
				----                1111111111222222222233333333 
				----       1234567890123456789012345678901234567
				--sMess = "You've earned 40 infamy points."; --debug purpose
				--sMess = "Vous avez gagn\195\169 60 points d'infamie"; --debug purpose
				--sMess = "Ihr habt 80 Verrufenheitspunkte erhalten."; --debug purpose

				if sMess ~= nil then
					if GLocale == "fr" then sS, sE = "Vous avez gagn\195\169", "points"; end

					if PlayerAlign == 1 then
						if GLocale == "en" then sS, sE = "You've earned", "renown";
						--elseif GLocale == "fr" then sS, sE = "Vous avez gagn\195\169", "points renomm\195\169e";
						elseif GLocale == "de" then sS, sE = "Ihr habt ", "Ansehenspunkte"; end
					else
						if GLocale == "en" then sS, sE = "You've earned", "infamy";
						--elseif GLocale == "fr" then sS, sE = "Vous avez gagn\195\169", "points d'infamie";
						elseif GLocale == "de" then sS, sE = "Ihr habt", "Verrufenheitspunkte"; end
					end

					local s,e = string.find(sMess, sS);
					if s ~= nil then
						local first = e + 1;
						local s,e = string.find(sMess, sE);
						local last = s - 1;
						-- Extract earned points from args.Message
						local pIPTS = string.sub( sMess, first, last );
						
						InfamyPTS = InfamyPTS + pIPTS;
						
						for i=0, 14 do
							if tonumber(InfamyPTS) >= InfamyRanks[i] and tonumber(InfamyPTS) < InfamyRanks[i+1] then InfamyRank = i; break end
						end

						settings.Infamy.P = InfamyPTS;
						settings.Infamy.K = InfamyRank;

						SaveSettings( false );
					end
				end
			end
		end);
		UpdateInfamy();
		IF["Ctr"]:SetPosition( _G.IFLocX, _G.IFLocY );
	elseif value == "GT" then --Game Time
		import (AppCtrD.."GameTime");
		--PlayerTime = Turbine.Engine.GetDate();
		--AddCallback(PlayerTime, "MinuteChanged", function(sender, args) UpdateGameTime(); end);
		if _G.ShowBT then UpdateGameTime("bt");
		elseif _G.ShowST then UpdateGameTime("st");
		else UpdateGameTime("gt") end
		GT["Ctr"]:SetPosition( _G.GTLocX, _G.GTLocY );
	end
end

function GetEquipmentInfos()
	LoadEquipmentTable();
	PlayerEquipment = Player:GetEquipment();
	if PlayerEquipment == nil then return end --Remove when Player Equipment info are available before plugin is loaded

	itemEquip = {};
	itemScore, numItems = 0, 0;
	
	for i = 1, 20 do
		local PlayerEquipItem = PlayerEquipment:GetItem( EquipSlots[Slots[i]] );
		itemEquip[i] = Turbine.UI.Lotro.ItemControl( PlayerEquipItem );

		-- Item Name, WearState, Quality & Durability
		if PlayerEquipItem ~= nil then
			itemEquip[i].Name = PlayerEquipItem:GetName();
			local Quality = PlayerEquipItem:GetQuality();-- deprecated
			itemEquip[i].Quality = Quality;
			local Durability = PlayerEquipItem:GetDurability();-- deprecated
			itemEquip[i].Durability = Durability;
			itemEquip[i].Item = true;

			if Quality == 5 then itemScore = 50; end -- Common
			if Quality == 4 then itemScore = 100; end -- Uncommon
			if Quality == 3 then itemScore = 150; end -- Incomparable
			if Quality == 2 then itemScore = 200; end -- Rare
			if Quality == 1 then itemScore = 250; end -- Legendary
			if Quality == 0 then itemScore = 0; end -- undefined
		
			if Durability == 0 then itemEquip[i].ItemPts = itemScore + 0; end -- undefined
			if Durability == 7 then itemEquip[i].ItemPts = itemScore + 5; end -- Weak / Faible
			if Durability == 1 then itemEquip[i].ItemPts = itemScore + 10; end -- Substantial
			if Durability == 2 then itemEquip[i].ItemPts = itemScore + 20; end -- Brittle / Fragile
			if Durability == 3 then itemEquip[i].ItemPts = itemScore + 30; end -- Normal
			if Durability == 4 then itemEquip[i].ItemPts = itemScore + 40; end -- Tought / Robuste
			if Durability == 5 then itemEquip[i].ItemPts = itemScore + 50; end -- Flimsy / Fragile ??
			if Durability == 6 then itemEquip[i].ItemPts = itemScore + 60; end -- Indestructible
			
			itemEquip[i].BImgID = PlayerEquipItem:GetBackgroundImageID();-- deprecated
			itemEquip[i].QImgID = PlayerEquipItem:GetQualityImageID();
			itemEquip[i].UImgID = PlayerEquipItem:GetUnderlayImageID();-- deprecated
			itemEquip[i].SImgID = PlayerEquipItem:GetShadowImageID();-- deprecated
			itemEquip[i].IImgID = PlayerEquipItem:GetIconImageID();-- deprecated

			WearState = PlayerEquipItem:GetWearState();
			itemEquip[i].WearState = WearState;
			if WearState ~= 0 then numItems = numItems + 1; end -- Undefined item must not be count (Pocket item are as Undefined Wear State, they are indestructible)
			
			if WearState == 2 then itemEquip[i].ItemDurPts = 100; end -- Pristine / parfait
			if WearState == 4 then itemEquip[i].ItemDurPts = 75; end -- Worn / us
			if WearState == 1 then itemEquip[i].ItemDurPts = 50; end -- Damaged / endommag
			if WearState == 3 then itemEquip[i].ItemDurPts = 0; end -- Broken / cass
			if WearState == 0 then itemEquip[i].ItemDurPts = 0; end -- undefined
			
			itemEquip[i].wsHandler = AddCallback(PlayerEquipItem, "WearStateChanged", function(sender, args) ChangeWearState(i); end);
			--itemEquip[i].ieHandler = AddCallback(PlayerEquipItem, "ItemEquipped", function(sender, args) UpdateEquipsInfos(i); end); --Add when each item can trigger this event
			--itemEquip[i].iuHandler = AddCallback(PlayerEquipItem, "ItemUnequipped", function(sender, args) UpdateEquipsInfos(i); end); --Add when each item can trigger this event
		else
			itemEquip[i].Name = "zEmpty";
			itemEquip[i].WearState = 0;
			itemEquip[i].Quality = 0;
			itemEquip[i].Durability = 0;
			itemEquip[i].ItemPts = 0;
			itemEquip[i].ItemDurPts = 0;
			itemEquip[i].Item = false;
		end
	end
end

function CalculateAllItemsDurability()
	itemsTotDurability = 0;

	for i = 1, 20 do
		itemsTotDurability = itemsTotDurability + itemEquip[i].ItemDurPts;
	end

	itemsTotDurability = itemsTotDurability / numItems;
end

function CalculateAllItemsScore()
	itemTotScore = 0;

	for i = 1, 20 do
		itemTotScore = itemTotScore + itemEquip[i].ItemPts;
	end
end

function LoadPlayerItemTrackingList()
	ITL = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarPlayerItemTrackingList" );
	if ITL == nil then ITL = {}; end
end

function SavePlayerItemTrackingList(ITL)
	local newt = {};
	for k, v in pairs(ITL) do newt[tostring(k)] = v; end
	ITL = newt;

	Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarPlayerItemTrackingList", ITL );
end

function LoadPlayerMoney()
	OldWallet = Turbine.PluginData.Load( Turbine.DataScope.Server, "TitanBarWallet" );

	wallet = Turbine.PluginData.Load( Turbine.DataScope.Server, "TitanBarPlayerWallet" );

	if wallet == nil then
		wallet = {};

		if OldWallet ~= nil then
			--Convert old user settings to new format
			for k,v in pairs(OldWallet) do -- k: key / v: value
				if string.sub( k, 1, 1 ) ~= "~" then --Ignore session play character
					-- Extract gold/silver/copper from string v
					local pos1 = string.find(v, "/", 0);
					local pos2 = string.find(v, "/", pos1 + 1);
			
					local OldUSerGold = string.sub(v, 1, pos1 - 1);
					local OldUSerSilver = string.sub(v, pos1 + 1, pos2 - 1);
					local OldUSerCopper = string.sub(v, pos2 + 1, string.len(v));

					wallet[k] = {};
					wallet[k].Gold = OldUSerGold;
					wallet[k].Silver = OldUSerSilver;
					wallet[k].Copper = OldUSerCopper;
					if k ~= "Total" then wallet[k].Show = true; end
				end
			end
		end
	end

	local PN = Player:GetName();
	if wallet[PN] == nil then wallet[PN] = {}; end
	if wallet[PN].Show == nil then wallet[PN].Show = true; end
	if wallet[PN].ShowToAll == nil then wallet[PN].ShowToAll = true; end
	_G.SCM = wallet[PN].Show;
	_G.SCMA = wallet[PN].ShowToAll;
end

-- **v Save player wallet infos v**
function SavePlayerMoney(str)
	local PN = Player:GetName();
	
	if string.sub( PN, 1, 1 ) == "~" then return end; --Ignore session play character

	wallet[PN].Gold = MI["GLbl"]:GetText();
	wallet[PN].Silver = MI["SLbl"]:GetText();
	wallet[PN].Copper = MI["CLbl"]:GetText();
	wallet[PN].Show = _G.SCM;
	wallet[PN].ShowToAll = _G.SCMA;

	if str then
		if wallet.Total == nil then wallet.Total = {}; end
		GoldTot, SilverTot, CopperTot = 0, 0, 0;
	
		for k,v in pairs(wallet) do
			if k ~= "Total" then
				if k == PN then
					if v.Show then
						local Gold = v.Gold;
						GoldTot = GoldTot + Gold;

						local Silver = v.Silver;
						SilverTot = SilverTot + Silver;

						local Copper = v.Copper;
						CopperTot = CopperTot + Copper;
					end
				else
					if v.ShowToAll or v.ShowToAll == nil then
						local Gold = v.Gold;
						GoldTot = GoldTot + Gold;

						local Silver = v.Silver;
						SilverTot = SilverTot + Silver;

						local Copper = v.Copper;
						CopperTot = CopperTot + Copper;
					end
				end
			end
		end

		--************************************************************************
		if (string.len(CopperTot)==3) then
			local CopperTotX = CopperTot;
			SilverTot = SilverTot + string.sub(CopperTotX,1,-3);
			CopperTot = string.sub(CopperTot,2,-1);
		end
		
		if (string.len(SilverTot)==4) then
			local SilverTotX = SilverTot;
			GoldTot = GoldTot + string.sub(SilverTotX,1,-4);
			SilverTot = string.sub(SilverTot,2,-1);
		end
		--************************************************************************

		wallet.Total.Gold = string.format("%.0f", GoldTot)
		wallet.Total.Silver = string.format("%.0f", SilverTot)
		wallet.Total.Copper = string.format("%.0f", CopperTot)
	end

	Turbine.PluginData.Save( Turbine.DataScope.Server, "TitanBarPlayerWallet", wallet );
end
-- **^

function LoadPlayerWallet()
	PlayerWallet = Player:GetWallet();
	PlayerWalletSize = PlayerWallet:GetSize();
	--write(tostring(PlayerWalletSize));
	if PlayerWalletSize == 0 then return end --Remove when Wallet info are available before plugin is loaded
	
	for i = 1, PlayerWalletSize do
		local CurItem = PlayerWallet:GetItem(i);
		local CurName = PlayerWallet:GetItem(i):GetName();

		PlayerCurrency[CurName] = CurItem;
		if PlayerCurrencyHandler[CurName] == nil then PlayerCurrencyHandler[CurName] = AddCallback(PlayerCurrency[CurName], "QuantityChanged", function(sender, args) UpdateCurrency(CurName); end); end
	end
end

function UpdateCurrency(str)
	if str == pwShard and ShowShards then UpdateShards(); end
	if str == pwMark and ShowSkirmishMarks then UpdateMarks(); end
	if str == pwMedallion and ShowMedallions then UpdateMedallions(); end
	if str == pwSeal and ShowSeals then UpdateSeals(); end
	if str == pwCommendation and ShowCommendations then UpdateCommendations(); end
end

function GetCurrency(str)
	CurQuantity = 0;
	
	for k,v in pairs(PlayerCurrency) do
		if k == str then
			CurQuantity = PlayerCurrency[str]:GetQuantity();
			break
		end
	end
	
	return CurQuantity
end